/*
 *  TOPPERS Software
 *      Toyohashi Open Platform for Embedded Real-Time Systems
 *
 *  Copyright (C) 2007 by TAKAGI Nobuhisa
 * 
 *  嵭Ԥϡʲ(1)(4)ξ˸¤ꡤܥեȥ
 *  ܥեȥѤΤޤࡥʲƱˤѡʣ
 *  ѡۡʰʲѤȸƤ֡ˤ뤳Ȥ̵ǵ롥
 *  (1) ܥեȥ򥽡ɤηѤˤϡ嵭
 *      ɽѾ浪Ӳ̵ݾڵ꤬Τޤޤηǥ
 *      ˴ޤޤƤ뤳ȡ
 *  (2) ܥեȥ򡤥饤֥ʤɡ¾Υեȥȯ˻
 *      ѤǤǺۤˤϡۤȼɥȡ
 *      ԥޥ˥奢ʤɡˤˡ嵭ɽѾ浪Ӳ
 *      ̵ݾڵǺܤ뤳ȡ
 *  (3) ܥեȥ򡤵Ȥ߹ʤɡ¾Υեȥȯ˻
 *      ѤǤʤǺۤˤϡΤ줫ξ
 *      ȡ
 *    (a) ۤȼɥȡѼԥޥ˥奢ʤɡˤˡ嵭
 *        ɽѾ浪Ӳ̵ݾڵǺܤ뤳ȡ
 *    (b) ۤη֤̤ˡˤäơTOPPERSץȤ
 *        𤹤뤳ȡ
 *  (4) ܥեȥѤˤľŪޤϴŪ뤤ʤ»
 *      ⡤嵭ԤTOPPERSץȤդ뤳ȡ
 *      ޤܥեȥΥ桼ޤϥɥ桼Τʤ
 *      ͳ˴Ťᤫ⡤嵭ԤTOPPERSץȤ
 *      դ뤳ȡ
 * 
 *  ܥեȥϡ̵ݾڤ󶡤ƤΤǤ롥嵭Ԥ
 *  TOPPERSץȤϡܥեȥ˴ؤơλŪ
 *  ФŬޤơʤݾڤԤʤޤܥեȥ
 *  ѤˤľŪޤϴŪʤ»˴ؤƤ⡤
 *  Ǥʤ
 * 
 */
#undef  BEGIN_KERNEL_CHK
#undef  END_KERNEL_CHK
#undef  KERNEL_CHK_SIZEOF
#undef  KERNEL_CHK_OFFSETOF
#undef  KERNEL_CHK_VALUEOF

#ifdef IMPLEMENT_KERNEL_CHK

#define BEGIN_KERNEL_CHK            ofile_ << "\t0x12345678,\n\tTKERNEL_PRID,\n"  \
                                              "\tCHAR_BIT,\n" \
                                              "\tCHAR_MAX,\n" \
                                              "\tSCHAR_MAX,\n" \
                                              "\tSHRT_MAX,\n" \
                                              "\tINT_MAX,\n" \
                                              "\tLONG_MAX,\n"
#define END_KERNEL_CHK              ;
#define KERNEL_CHK_SIZEOF( sym )    KERNEL_CHK_SIZEOF_( sym )
#define KERNEL_CHK_SIZEOF_( sym )   "\tsizeof(" #sym "),\n"
#define KERNEL_CHK_OFFSETOF( type, member )  "\toffsetof(" #type ", " #member "),\n"
#define KERNEL_CHK_VALUEOF( expr )  "\t" #expr ",\n"

#else

#define BEGIN_KERNEL_CHK            enum { magic_number, TKERNEL_PRID, \
                                           valueof_CHAR_BIT, \
                                           valueof_CHAR_MAX, \
                                           valueof_SCHAR_MAX, \
                                           valueof_SHRT_MAX, \
                                           valueof_INT_MAX, \
                                           valueof_LONG_MAX,
#define END_KERNEL_CHK              kernel_chk_table_size };
#define KERNEL_CHK_SIZEOF( sym )    sizeof_##sym,
#define KERNEL_CHK_OFFSETOF( type, member )  offsetof_##type##_##member,
#define KERNEL_CHK_VALUEOF( expr )  valueof_##expr,

#endif
